// ADSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ADSample.h"
#include "ADSampleDlg.h"
#include "DetectDialog.h"
#include "aiousb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

unsigned short * ADData;
const int ADDataSize = 16 * 4*1024L*1024L * 2; //4M scans of 16 channels, or 8M scans of 8 differential channels.

/////////////////////////////////////////////////////////////////////////////
// CADSampleDlg dialog

CADSampleDlg::CADSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CADSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CADSampleDlg)
	m_calFName = _T("");
	m_bDifferential = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

int CADSampleDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	ADData = (unsigned short *)malloc(ADDataSize);
	
	return 0;
}

void CADSampleDlg::OnDestroy() 
{
	free(ADData);

	CDialog::OnDestroy();
}

void CADSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CADSampleDlg)
	DDX_Control(pDX, IDC_VLBLE, m_VoltLabelE);
	DDX_Control(pDX, IDC_VLBLD, m_VoltLabelD);
	DDX_Control(pDX, IDC_VLBLC, m_VoltLabelC);
	DDX_Control(pDX, IDC_VLBLB, m_VoltLabelB);
	DDX_Control(pDX, IDC_VLBLA, m_VoltLabelA);
	DDX_Control(pDX, IDC_VLBL9, m_VoltLabel9);
	DDX_Control(pDX, IDC_VLBL8, m_VoltLabel8);
	DDX_Control(pDX, IDC_VLBL7, m_VoltLabel7);
	DDX_Control(pDX, IDC_VLBL6, m_VoltLabel6);
	DDX_Control(pDX, IDC_VLBL5, m_VoltLabel5);
	DDX_Control(pDX, IDC_VLBL4, m_VoltLabel4);
	DDX_Control(pDX, IDC_VLBL3, m_VoltLabel3);
	DDX_Control(pDX, IDC_VLBL2, m_VoltLabel2);
	DDX_Control(pDX, IDC_VLBL1, m_VoltLabel1);
	DDX_Control(pDX, IDC_VLBL0, m_VoltLabel0);
	DDX_Control(pDX, IDC_VLBLF, m_VoltLabelF);
	DDX_Control(pDX, IDC_GO_BUTTON, m_goBTN);
	DDX_Control(pDX, IDC_RANGE_COMBO, m_rangeBox);
	DDX_Control(pDX, IDC_PROGRESSF, m_progressF);
	DDX_Control(pDX, IDC_PROGRESSE, m_progressE);
	DDX_Control(pDX, IDC_PROGRESSD, m_progressD);
	DDX_Control(pDX, IDC_PROGRESSC, m_progressC);
	DDX_Control(pDX, IDC_PROGRESSB, m_progressB);
	DDX_Control(pDX, IDC_PROGRESSA, m_progressA);
	DDX_Control(pDX, IDC_PROGRESS9, m_progress9);
	DDX_Control(pDX, IDC_PROGRESS8, m_progress8);
	DDX_Control(pDX, IDC_PROGRESS7, m_progress7);
	DDX_Control(pDX, IDC_PROGRESS6, m_progress6);
	DDX_Control(pDX, IDC_PROGRESS5, m_progress5);
	DDX_Control(pDX, IDC_PROGRESS4, m_progress4);
	DDX_Control(pDX, IDC_PROGRESS3, m_progress3);
	DDX_Control(pDX, IDC_PROGRESS2, m_progress2);
	DDX_Control(pDX, IDC_PROGRESS1, m_progress1);
	DDX_Control(pDX, IDC_PROGRESS0, m_progress0);
	DDX_Text(pDX, IDC_CAL_EDIT, m_calFName);
	DDX_Check(pDX, IDC_DIFFCHECK, m_bDifferential);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CADSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CADSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_RANGE_COMBO, OnSelchangeRangeCombo)
	ON_BN_CLICKED(IDC_GO_BUTTON, OnGoButton)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_DIFFCHECK, OnDiffCheckClick)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CADSampleDlg message handlers

BOOL CADSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	DetectDialog DetectBox;

	unsigned long Status, PID, ConfigBufSize;
	double Hz;
	int count;


	DeviceIndex = diOnly;

	//If you only have the one board, QueryDeviceInfo() with diOnly will succeed
  //with the right PID. If you have more than one board, or haven't plugged it
  //in, it will fail, and this code will pop up the detector form so the user
  //can pick a board or cancel.

	Status = QueryDeviceInfo(DeviceIndex, &PID, NULL, NULL, NULL, NULL);

	PID &= 0xFFF0;

	if ((Status != ERROR_SUCCESS) || (PID != 0x8040))
	{
		if (DetectBox.DoModal() == IDOK)
		{
			DeviceIndex = DetectBox.index;
		}
		else
		{
			exit(1);
		}
	}

	VoltProgress[0x0] = &m_progress0;
	VoltProgress[0x1] = &m_progress1;
	VoltProgress[0x2] = &m_progress2;
	VoltProgress[0x3] = &m_progress3;
	VoltProgress[0x4] = &m_progress4;
	VoltProgress[0x5] = &m_progress5;
	VoltProgress[0x6] = &m_progress6;
	VoltProgress[0x7] = &m_progress7;
	VoltProgress[0x8] = &m_progress8;
	VoltProgress[0x9] = &m_progress9;
	VoltProgress[0xA] = &m_progressA;
	VoltProgress[0xB] = &m_progressB;
	VoltProgress[0xC] = &m_progressC;
	VoltProgress[0xD] = &m_progressD;
	VoltProgress[0xE] = &m_progressE;
	VoltProgress[0xF] = &m_progressF;

	VoltLabel[0x0] = &m_VoltLabel0;
	VoltLabel[0x1] = &m_VoltLabel1;
	VoltLabel[0x2] = &m_VoltLabel2;
	VoltLabel[0x3] = &m_VoltLabel3;
	VoltLabel[0x4] = &m_VoltLabel4;
	VoltLabel[0x5] = &m_VoltLabel5;
	VoltLabel[0x6] = &m_VoltLabel6;
	VoltLabel[0x7] = &m_VoltLabel7;
	VoltLabel[0x8] = &m_VoltLabel8;
	VoltLabel[0x9] = &m_VoltLabel9;
	VoltLabel[0xA] = &m_VoltLabelA;
	VoltLabel[0xB] = &m_VoltLabelB;
	VoltLabel[0xC] = &m_VoltLabelC;
	VoltLabel[0xD] = &m_VoltLabelD;
	VoltLabel[0xE] = &m_VoltLabelE;
	VoltLabel[0xF] = &m_VoltLabelF;

	if ( ADC_QueryCal(DeviceIndex) != ERROR_SUCCESS )
	{
		//this board doesn't have calibration
	}

	//Stop the counter, in case it was running.
	Hz = 0;

	CTR_StartOutputFreq(DeviceIndex, 0, &Hz);

	m_rangeBox.SetCurSel(0);

	OnSelchangeRangeCombo();

	ZeroMemory(&Config, sizeof(Config));
	Config.CalibMode = 0; //Take actual data, not internal calibration sources.
	Config.TrigMode = 5; //Scan selected channels each counter rising edge.
	Config.Oversample = 0;//No oversample.
	ConfigBufSize = sizeof(Config);
	ADC_SetConfig (DeviceIndex, &Config, &ConfigBufSize);
	NextChannel = 0;


	for (count = 0; count < 0xF; count++)
	{
		VoltProgress[count] -> SetRange32(0, 0xFFFF);
		VoltProgress[count] -> SetPos(0);
	}

	m_calFName = ":AUTO:";

	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CADSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CADSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CADSampleDlg::OnSelchangeRangeCombo()
{
	int I;
	byte RangeCode;

	//The ranges in the combo box are listed in order, so that the index is equal
    //to the range code.

	RangeCode = m_rangeBox.GetCurSel();
    if ( m_bDifferential ) RangeCode |= 0x08;

	for (I = 0; I < 0xF; I++)
		Config.ChannelRange[I] = RangeCode;
}

void CADSampleDlg::OnDiffCheckClick() 
{
	OnSelchangeRangeCombo();
}

void CADSampleDlg::OnGoButton() 
{
	double Hz;
	unsigned long Status;
	unsigned long ConfigBufSize;
	char *buf;

	UpdateData(true);

	if ( m_bDifferential )
		Config.StartStopCH = 0x70; //Select all 8 differential channels, from 0 to 7.
	else
		Config.StartStopCH = 0xF0 //Select all 16 channels, from 0 to 15.
	;
	ConfigBufSize = sizeof(Config);
	ADC_SetConfig(DeviceIndex, &Config, &ConfigBufSize);
	NextChannel = 0;

	m_rangeBox.EnableWindow(false);
	m_goBTN.EnableWindow(false);

	bGoing = true;

	buf = m_calFName.GetBuffer(m_calFName.GetLength());

	Status = ADC_SetCal(DeviceIndex, buf);

	m_calFName.ReleaseBuffer(-1);

	if (Status == ERROR_SUCCESS)
		;//it worked
	else if (Status == ERROR_NOT_SUPPORTED)
		;
	else
	{
		m_rangeBox.EnableWindow(true);
		m_goBTN.EnableWindow(true);
		bGoing = false;
		CString errString;
		errString.Format("Calibration Error %d", Status);
		MessageBox(errString, "error", MB_OK);
		return;
	}

	KnownBytesLeft = ADDataSize;
	ADC_BulkAcquire(DeviceIndex, KnownBytesLeft, ADData);
	NextSample = 0;

	Sleep(1);

	//Start the counter.
	Hz = 9000;
	CTR_StartOutputFreq(DeviceIndex, 0, &Hz);
	
	SetTimer(1, 1, NULL);
	
}



void CADSampleDlg::OnTimer(UINT nIDEvent) 
{

	unsigned long BytesLeft;
	double Volts;
	byte RangeCode;
	double Hz;
	unsigned short Counts;
	CString LabelString;

	ADC_BulkPoll(DeviceIndex, &BytesLeft);

	if (BytesLeft >= KnownBytesLeft) return;

	//If we get here, some data has been taken.
	if (BytesLeft == 0)
	{
		//Stop the counter.
		Hz = 0;
		CTR_StartOutputFreq(DeviceIndex, 0, &Hz);
		m_goBTN.EnableWindow(true);
		m_rangeBox.EnableWindow(true);
		bGoing = false;
	}

	//We're going to use the range code to convert to volts.
	RangeCode = m_rangeBox.GetCurSel();

	do
	{
		Counts = ADData[NextSample];
		VoltProgress[NextChannel] -> SetPos(Counts);

		Volts = double(Counts) / double(0xFFFF); //"Volts" now holds a value from 0 to 1.
    
		if ((RangeCode & 0x01) != 0) //Bit 0(mask 01 hex) indicates bipolar.
		{
			Volts = Volts * 2 - 1; //"Volts" now holds a value from -1 to +1.
		}
		if ((RangeCode & 0x02) == 0) //Bit 1(mask 02 hex) indicates x2 gain.
		{
			Volts *= 2;
		}
		if ((RangeCode & 0x04) == 0) //Bit 2(mask 04 hex) indicates x5 gain.
		{
			Volts *= 5;
		}
		//"Volts" now holds volts.

		LabelString.Format("Ch %d: %.2fV", NextChannel, Volts);
		VoltLabel[NextChannel]->SetWindowText(LabelString);
		//VoltLabel[NextChannel]->Format("Ch %d: %04Xct", NextChannel, Counts);

		NextSample++;
		if ( m_bDifferential )
			NextChannel = (NextChannel + 1) % 8;
		else
			NextChannel = (NextChannel + 1) % 16
		;
		KnownBytesLeft -= 2;


		
	}while (KnownBytesLeft != BytesLeft);



	CDialog::OnTimer(nIDEvent);
}
